package dev.shadowsoffire.apotheosis.mixin;

package .tmp;

import dev.shadowsoffire.apotheosis.ench.Ench;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.network.chat.TextColor;
import net.minecraft.world.item.enchantment.Enchantment;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(value = {Enchantment.class}, priority = 1500)
public class EnchantmentMixin {
  @Inject(method = {"getFullname"}, at = {@At("RETURN")}, cancellable = true)
  public void apoth_modifyEnchColorForAboveMaxLevel(int level, CallbackInfoReturnable<Component> cir) {
    Enchantment ench = (Enchantment)this;
    if (!ench.m_6589_() && level > ench.m_6586_()) {
      Object object = cir.getReturnValue();
      if (object instanceof MutableComponent) {
        MutableComponent mc = (MutableComponent)object;
        cir.setReturnValue(mc.m_130938_(s -> s.m_131148_((TextColor)Ench.Colors.LIGHT_BLUE_FLASH)));
      } 
    } 
  }
}
